EXTPROC CEnvi

#define HWND_DESKTOP 1
#define HWND_OBJECT  2

printf("Desktop Windows:");
EnumerateAllChildren(HWND_DESKTOP,1);
printf("\nObject Windows:");
EnumerateAllChildren(HWND_OBJECT,1);


EnumerateAllChildren(ParentHandle,IndentLevel)
{
   EnumHandle = WinBeginEnumWindows(ParentHandle);
   while( NULL != (WinHandle = WinGetNextWindow(EnumHandle)) ) {
      Queue = GetWindowQueue(WinHandle);
      printf("\n");
      for ( i = 0; i < IndentLevel; i++ ) printf(" ");
      printf("%08X  queue = %04X",WinHandle,Queue);
      EnumerateAllChildren(WinHandle,IndentLevel+1);
   }
   WinEndEnumWindows(EnumHandle);
}

WinBeginEnumWindows(hwndParent)
{
   #define ORD_WIN32BEGINENUMWINDOWS   702
   return PMDynamicLink("PMWIN",ORD_WIN32BEGINENUMWINDOWS,BIT32,CDECL,hwndParent)
}

WinGetNextWindow(henum)
{
   #define ORD_WIN32GETNEXTWINDOW      756
   return PMDynamicLink("PMWIN",ORD_WIN32GETNEXTWINDOW,BIT32,CDECL,henum)
}

WinEndEnumWindows(henum)
{
   #define ORD_WIN32ENDENUMWINDOWS     737
   return PMDynamicLink("PMWIN",ORD_WIN32ENDENUMWINDOWS,BIT32,CDECL,henum)
}

GetWindowQueue(hwnd)
{
   #define ORD_WIN32QUERYWINDOWULONG   843
   #define QWL_HMQ   (-4)
   return PMDynamicLink("PMWIN",ORD_WIN32QUERYWINDOWULONG,BIT32,CDECL,
                        hwnd,QWL_HMQ)
}

ShowQueueInfo(hmq)
{
   #define ORD_WIN32QUERYQUEUEINFO  824
   BLOBSize(qinfo,4 * 5);
   success = PMDynamicLink("PMWIN",ORD_WIN32QUERYQUEUEINFO,BIT32,CDECL,
                           hmq,qinfo,BLObSize(qinfo));
   if ( !success ) {
      printf("QInfo failed\n");
   } else {
      MessageCount = BLObGet(qinfo,4 * 3,UWORD32);
      printf("  MessageCount = %d",MessageCount);
   }
}

