EXTPROC CEnvi.exe
// PageBrk.cmd - replace all instances of a page break
//               in a text file with cr-lf.  This is used
//               because AmiPro screws up and only makes
//               ascii files with an extra page break but
//               then makes no new-line.


#define  PAGE_BREAK  ''

main(argc,argv)
{
   if ( 2 != argc  ||  !strcmp(argv[1],"/?") )
      ShowInstructions();
   else {
      FileName = argv[1];
      assert( NULL != (TempFileName = tmpnam()) );
      // open files for input and output
      infp = fopen(FileName,"rt");
      if ( NULL == infp )
         printf("\aCould not open %s for input\n",);
      else {
         assert( NULL != (outfp = fopen(TempFileName,"wt")) );
         // read in each line, scan for PAGE_BREAK, then write
         while ( NULL != (text = fgets(infp)) ) {
            pbreak = strchr(text,PAGE_BREAK);
            if ( pbreak == NULL ) {
               fputs(text,outfp);
            } else {
               // write up to break, and then beyond break
               pbreak[0] = 0;
               fprintf(outfp,"%s\n",text);
               fputs(pbreak+1,outfp);
            }
         }
         fclose(infp);
         fclose(outfp);
         // remove the input file, then copy output to input and remove output
         system("DelDel.cmd %s",FileName);
         system("copy %s %s > NUL",TempFileName,FileName);
         system("DelDel.cmd %s",TempFileName);
      }
   }
}

ShowInstructions()
{
   printf("\n")
   printf("PageBrk - Remove page breaks from a text file, and make them newlines\a\n")
   printf("\n")
   printf("SYNTAX: PageBrk FileName...\n")
   printf("\n")
   printf("Where: FileName is the text file to convert. It will be overwritten.\n")
}
